/******************************************************************************/
/*                                                                            */
/*    Copyright (c)The 3Delight Developers.                                   */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/******************************************************************************/

// ===========================================================================
// = LIBRARY
//     3delight
// = FILENAME
//     dlInterface.h
// = AUTHOR(S)
//     Marco Jacques
// = VERSION
//     $Revision: 1.5 $
// = DATE RELEASED
//     $Date: 2003/06/30 18:44:51 $
// = RCSID
//     $Id: dlInterface.h,v 1.5 2003/06/30 18:44:51 aghiles Exp $
// = COPYRIGHT
//     Copyright  1999-2000 The 3Delight Developers.
//     All Rights Reserved.
// ===========================================================================

//////////////////////////////////////////////////////////////////////////////
// This will be included for files which must import or export symbol from
// the 3DL library.  It will avoid having the required definitions scattered 
// at differents places
//////////////////////////////////////////////////////////////////////////////

#ifndef __dlInterface_H
#define __dlInterface_H

//////////////////////////////////////////////////////////////////////////////
// Macro DL_INTERFACE
//
// This macro prefixes functions and variables that are exported from the
// 3Dl library.  For IRIX and Linux, this macro does nothing.  On NT, we
// must declare that we import symbols if we are using the library (when
// we are compiling shaders and the ribreader), or we are exporting the
// symbol (when we compile the library itself).
//////////////////////////////////////////////////////////////////////////////

#ifdef WIN32

#if defined(DL_COMPILING_SHADER) || \
	defined(DL_COMPILING_RENDERDL) || \
	defined(DL_COMPILING_DRIVER)
#define DL_INTERFACE __declspec(dllimport)
#else
#define DL_INTERFACE __declspec(dllexport)
#endif

#else
#define DL_INTERFACE
#endif // WIN32

//////////////////////////////////////////////////////////////////////////////
// Macro DL_EXPORT_VAR
//
// This macro is used only in cpp files for exporting variables.
//////////////////////////////////////////////////////////////////////////////

#ifdef WIN32
#define DL_EXPORT_VAR __declspec(dllexport)
#else
#define DL_EXPORT_VAR
#endif // WIN32


#endif // __dlInterface_H
