/******************************************************************************/
/*                                                                            */
/*    Copyright (c)The 3Delight Developers.                                   */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/******************************************************************************/

// ===========================================================================
// = LIBRARY
//     3delight
// = FILENAME
//     dlLightHidden.h
// = AUTHOR(S)
//     Patrick Fournier
// = VERSION
//     $Revision: 1.10 $
// = DATE RELEASED
//     $Date: 2002/04/02 20:20:01 $
// = RCSID
//     $Id: dlLightHidden.h,v 1.10 2002/04/02 20:20:01 aghiles Exp $
// = COPYRIGHT
//     Copyright  1999-2000 The 3Delight Developers.
//     All Rights Reserved.
// ===========================================================================

#ifndef __dlLightHidden_H
#define __dlLightHidden_H

#include "dlTokenInfo.h"
#include "dlVar.h"
#include "dlBasicTypes.h"
#include "dlHidden.h"

class DlTokenRegWithDefault;


// ===========================================================================
//
//      CLASS DlLightHidden
//
// ===========================================================================

/**
  DlLightHidden.

  \begin{description}

  \item[CLASS TYPE]
  --

  \item[DESCRIPTION]
  --

  \item[NOTES]
  --

  \end{description}
  This class is used to store values for a light hidden parameters.

  @author Patrick Fournier
  @see --
  */
class DlLightHidden : public DlHidden
{
public:
	DlLightHidden();
	~DlLightHidden();

	virtual void Init( const DlTokenRegWithDefault*, unsigned i_neededMask );

	DlVector3* GetL(void) const { return m_L ? (DlVector3*)m_L->Value() : 0x0; }
	DlVector3* GetPs(void) const { return m_Ps ? (DlVector3*)m_Ps->Value() : 0x0; }
	DlRGBColor* GetCl(void) const { return m_Cl ? (DlRGBColor*)m_Cl->Value() : 0x0; }
	DlRGBColor* GetOl(void) const { return m_Ol ? (DlRGBColor*)m_Ol->Value() : 0x0; }

	void SetL(const DlTokenInfo::DlClass&, unsigned i_numValues, void* i_value);
	void SetPs(const DlTokenInfo::DlClass&, unsigned i_numValues, void* i_value);
	void SetCl(const DlTokenInfo::DlClass&, unsigned i_numValues, void* i_value);
	void SetOl(const DlTokenInfo::DlClass&, unsigned i_numValues, void* i_value);

	virtual DlVar *GetVar( DlHidden::hiddenNames i_name, DlVar ***o_adr ) const;

 protected:
	DlVar* m_L;
	DlVar* m_Ps;

	DlVar* m_Cl;
	DlVar* m_Ol;
};

#endif
