/******************************************************************************/
/*                                                                            */
/*    Copyright (c)The 3Delight Developers.                                   */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/******************************************************************************/

// ===========================================================================
// = LIBRARY
//     3delight
// = FILENAME
//     dlLightInput.h
// = AUTHOR(S)
//     Patrick Fournier
// = VERSION
//     $Revision: 1.8 $
// = DATE RELEASED
//     $Date: 2002/11/13 19:48:21 $
// = RCSID
//     $Id: dlLightInput.h,v 1.8 2002/11/13 19:48:21 aghiles Exp $
// ===========================================================================

#ifndef __dlLightInput_H
#define __dlLightInput_H

#include "dlBasicTypes.h"

class DlLight;

class DlLightInput
{
public:
	DlLightInput()
	{
        m_light = 0x0;
		L = 0x0;
		Cl = 0x0;
		Ol = 0x0;
	}

	const DlLight *Light( void ) const { return m_light; }

/* TODO protected: */
    DlLight* m_light;           // Light shader
	DlVector3* L;               // Ray direction (for each mp)
	DlRGBColor* Cl;             // Ray color ( for each mp )
	DlRGBColor* Ol;             // Ray opacity ( for each mp )
};

#endif
