/******************************************************************************/
/*                                                                            */
/*    Copyright (c)The 3Delight Developers.                                   */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/******************************************************************************/


// ===========================================================================
// = LIBRARY
//     3delight
// = FILENAME
//     dlShaderInterface.h
// = AUTHOR(S)
//     Patrick Fournier
// = VERSION
//     $Revision: 1.5 $
// = DATE RELEASED
//     $Date: 2001/05/11 22:26:08 $
// = RCSID
//     $Id: dlShaderInterface.h,v 1.5 2001/05/11 22:26:08 aghiles Exp $
// = COPYRIGHT
//     Copyright  1999-2000 The 3Delight Developers.
//     All Rights Reserved.
// ===========================================================================


#ifndef __dlShaderInterface_H
#define __dlShaderInterface_H


// ===========================================================================
//      C L A S S E S
// ===========================================================================


// ===========================================================================
//
//      CLASS DlShaderInterface
//
// ===========================================================================


/** 
  External interface for shaders.

  \begin{description}

  \item[CLASS TYPE]
  --

  \item[DESCRIPTION]
  --

  \item[NOTES]
  --
  
  \end{description}

  @author Patrick Fournier
  @see --
  */
class DlShaderInterface
{
public:

    typedef enum
    {
        e_typeBad = -1,			// Shader type given by dso does not match expected type

        e_typeSurface = 0,
        e_typeDisplacement = 1,
        e_typeVolume = 2,
        e_typeLight = 3,
        e_typeImager = 4,
        e_typeUnknown,			// Unknown shader type
        e_typeTransformation
    } DlType;

	enum { k_maxShader = 5 }; // number of supported shaders
			
	typedef struct {
		unsigned int	m_numVisible;	// number of visible variables
		unsigned int	m_numHidden;	// number of hidden variables
		unsigned int	m_localUniformSize;	// size, in byte, of the DlLocalUniform struct
		unsigned int	m_localVaryingSize;	// size, in byte, of the DlLocalVarying struct
        unsigned int m_numSpaces; // number of spaces in space list
	} DlDataSize;


};


#endif // __dlShaderInterface_H

