/******************************************************************************/
/*                                                                            */
/*    Copyright (c)The 3Delight Team.                                         */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/******************************************************************************/

light
spotlight(
	float intensity = 1;
	color lightcolor = 1;
	uniform string shadowmap = "";
	uniform float blur = 0;
	point from = point "shader" (0,0,0);
	point to = point "shader" (0,0,1);
	float coneangle = radians(30);
	float conedeltaangle = radians(5);
	float beamdistribution = 2;)
{
	uniform point A = (to - from) / length(to - from);

	illuminate( from, A, coneangle ) 
	{
		color shad = shadow( shadowmap, Ps, "blur", blur );

		float cosangle = L.A / length( L );

		float atten = pow(cosangle, beamdistribution) / (L.L);

		atten *=
			smoothstep( cos(coneangle),
				cos(coneangle - conedeltaangle), cosangle );

		Cl = atten * (1-shad) * intensity * lightcolor;
	}
}
